.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm			; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
	LOOP_COUNT	= 1000000-1
		; 1000000 would be a typical value

.data
Src	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos.", 0

.code
start:
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call RevString
	counter_end
	print str$(eax), 9, "cycles for RevString", 13, 10
	print offset Src, 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		push offset Src
		call szRev
	counter_end
	print str$(eax), 9, "cycles for szRev", 13, 10
	print offset Src, 13, 10

	inkey chr$(13, 10, "--- ok ---", 13)
	exit

RevString proc
	push esi
	push edi
	mov esi, [esp+4+8]
	mov edi, esi
	add edi, len(edi)		; you must know the end of the string
	shr eax, 3			; len div 8 - we use dwords and meet in the middle
	je @F
	.Repeat
		sub edi, 4
		mov ecx, [esi]
		mov edx, [edi]
		bswap ecx
		bswap edx
		mov [edi], ecx
		mov [esi], edx
		add esi, 4
		dec eax
	.Until Zero?
@@:	dec edi
	cmp edi, esi
	jbe @F
	movzx eax, byte ptr [esi]
	movzx edx, byte ptr [edi]
	mov [esi], dl
	mov [edi], al
	inc esi
	jmp @B
@@:
	pop edi
	pop esi
	ret 4
RevString endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]